﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Reflection;
using CustomHelper;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using Telerik.Pivot.Core;

namespace ICustomTypeProviderSample
{

    public partial class MainPage : UserControl
    {

        public ObservableCollection<Customer> customers = new ObservableCollection<Customer>();
        public ObservableCollection<Product> products = new ObservableCollection<Product>();

        public MainPage()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            if (button1.IsEnabled == true)
            {
               
                Customer.AddProperty("Age", typeof(int));
             
                Customer.AddProperty("Married", typeof(bool));
                             
                Customer customer1 = new Customer { FirstName = "Mary", LastName = "Smith" };
                customer1.SetPropertyValue("Age", 40);
                customer1.SetPropertyValue("Married", true);

              
                Customer customer2 = new Customer { FirstName = "John", LastName = "Smith" };
                customer2.SetPropertyValue("Age", 45);
                customer2.SetPropertyValue("Married", true);

                customers.Add(customer1);
                customers.Add(customer2);

                Product.AddProperty("Available", typeof(bool));

                Product product1 = new Product { ProductName = "Soap", Price = 2, LaunchDate = new DateTime(2012, 09, 15) };
                product1.SetPropertyValue("Available", true);

                products.Add(product1);


                var dataProviderCustomers = (this.Resources["LocalDataProviderCustomers"] as LocalDataSourceProvider);
                dataProviderCustomers.ItemsSource = customers;
                this.PivotGridCustomers.DataProvider = dataProviderCustomers; 

                var dataProviderProducts = (this.Resources["LocalDataProviderProducts"] as LocalDataSourceProvider);
                dataProviderProducts.ItemsSource = products;
                this.PivotGridProducts.DataProvider = dataProviderProducts;

                button1.IsEnabled = false;
            }            
        }
    }

    //Inheritance

    public class Product : CustomTypeHelper<Product>
    {
        public String ProductName { get; set; }

        public int Price { get; set; }
        
        public DateTime LaunchDate { get; set; }
    }

    // Interface

    public class Customer : ICustomTypeProvider
    {       
        public String FirstName { get; set; }
        public String LastName { get; set; }

        CustomTypeHelper<Customer> helper = new CustomTypeHelper<Customer>();


        public static void AddProperty(String name)
        {
            CustomTypeHelper<Customer>.AddProperty(name);
        }

        public static void AddProperty(String name, Type propertyType)
        {
            CustomTypeHelper<Customer>.AddProperty(name, propertyType);
        }

        public static void AddProperty(String name, Type propertyType, List<Attribute> attributes)
        {
            CustomTypeHelper<Customer>.AddProperty(name, propertyType, attributes);
        }

        public void SetPropertyValue(string propertyName, object value)
        {
            helper.SetPropertyValue(propertyName, value);
        }

        public object GetPropertyValue(string propertyName)
        {
            return helper.GetPropertyValue(propertyName);
        }

        public PropertyInfo[] GetProperties()
        {
            return helper.GetProperties();
        }

        public Type GetCustomType()
        {
            return helper.GetCustomType();
        }
    }
}
